/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryYAxis } from "./CategoryYAxis";
import { IVerticalAnchoredCategorySeriesInteractionManager_$type } from "./IVerticalAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-angular-core";
import { runOn, typeCast, EnumUtil, markType, markDep } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { TrendLineType_$type } from "igniteui-angular-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate } from "igniteui-angular-core";
/**
 * @hidden
 */
export class VerticalAnchoredCategorySeries extends AnchoredCategorySeries {
    constructor() {
        super(...arguments);
        this.pz = null;
    }
    ht() {
        super.ht();
        this.xAxis = null;
        this.yAxis = null;
    }
    get p0() {
        if (this.pz == null) {
            this.pz = DVContainer.instance.createInstance(IVerticalAnchoredCategorySeriesInteractionManager_$type, () => this.b2.n);
        }
        return this.pz;
    }
    get_isVertical() {
        return true;
    }
    m6() {
        return this.yAxis;
    }
    nq() {
        return this.xAxis;
    }
    getOffsetValue() {
        return this.nb.r(this.m6(), this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    getCategoryWidth() {
        return this.yAxis.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    fc(a, b) {
        return this.fd(a, b, this.m6(), runOn(this, this.n5), this.valueColumn);
    }
    fe(a, b) {
        return this.ff(a, b, this.m6(), runOn(this, this.n5), this.valueColumn);
    }
    d9(a, b, c, d, e) {
        if (this.valueColumn == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.ea(a, b, this.yAxis, d, e, this.valueColumn.count, runOn(this, this.n5));
    }
    bd() {
        if (this.be == 0) {
            return 1;
        }
        else {
            return super.bd();
        }
    }
    lw(a) {
        if (!this.hasMarkers || !this.l3()) {
            return Rect.empty;
        }
        return this.p0.e$b(this, this.m7.m, a, runOn(this, this.p8));
    }
    p8(a) {
        return this.oy.c5(a);
    }
    dh(a, b) {
        if (this.dg(a, b)) {
            return true;
        }
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    }
    en(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.m6();
        let f = new ScalerParams(0, this.bs.mq, this.bi.br, e.b8, d);
        let g = this.nb.r(e, this.bs.mq, this.bi.br, d);
        return this.ep(this.valueColumn, a, e, f, g, runOn(this, this.n5), b, c);
    }
    ll(a, b, c) {
        let d = this.m6();
        return this.ln(a, b, c, this.nb.r(d, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.nq(), d, null, null, null);
    }
    fetchXAxis() {
        return this.xAxis;
    }
    fetchYAxis() {
        return this.yAxis;
    }
    pg(a) {
        this.xAxis = typeCast(NumericXAxis.$, a);
    }
    ph(a) {
        this.yAxis = typeCast(CategoryYAxis.$, a);
    }
    n1() {
        return this.xAxis != null && this.xAxis.cl();
    }
    m0(a, b) {
        return this.ov(a, b, this.yAxis);
    }
    eb(a) {
        return this.p0.e$a(this, a);
    }
    n5(a) {
        return this.ed(a, this.m6());
    }
    e8(a) {
        return truncate(Math.round(this.eb(a)));
    }
    fp(a) {
        let b = this.e8(a);
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    }
    iz(a, b, c, d) {
        super.iz(a, b, c, d);
        switch (b) {
            case VerticalAnchoredCategorySeries.$$p[0]:
                if (c != d) {
                    this.hz(typeCast(Axis.$, c));
                    this.i4(typeCast(Axis.$, d));
                    this.nf.cn.g(this.eu);
                    this.jd(false);
                    this.ik();
                }
                break;
            case VerticalAnchoredCategorySeries.$$p[1]:
                if (c != d) {
                    this.hz(typeCast(Axis.$, c));
                    this.i4(typeCast(Axis.$, d));
                    this.nf.cn.g(this.eu);
                    this.n1();
                    this.jd(false);
                    this.ik();
                }
                break;
            case "TrendLineType":
                let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.oy.cy = CategoryTrendLineManagerFactory.a(this.oy.cy, this.yAxis, this.jx, this, this.b2);
                }
                break;
        }
    }
    p3(a) {
        if (typeCast(CategoryYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    p2(a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    get useHighMarkerFidelity() {
        return this.n2;
    }
}
VerticalAnchoredCategorySeries.$t = markType(VerticalAnchoredCategorySeries, 'VerticalAnchoredCategorySeries', AnchoredCategorySeries.$);
VerticalAnchoredCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, VerticalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::p6', [NumericXAxis.$, null], 'YAxis::p7', [CategoryYAxis.$, null]]);
//# sourceMappingURL=VerticalAnchoredCategorySeries.js.map