var IgxScatterPolylineSeriesComponent_1;
import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxStyle } from "igniteui-angular-core";
import { IgxShapeSeriesBaseComponent } from "./igx-shape-series-base-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { ScatterPolylineSeries } from "./ScatterPolylineSeries";
/**
 * Series class used for displaying multiple polylines for datasources which contain multiple lists of points.
*/
export const IgxScatterPolylineSeriesComponent_PROVIDERS = [{ provide: IgxShapeSeriesBaseComponent, useExisting: forwardRef(() => IgxScatterPolylineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterPolylineSeriesComponent) }];
let IgxScatterPolylineSeriesComponent = IgxScatterPolylineSeriesComponent_1 = class IgxScatterPolylineSeriesComponent extends IgxShapeSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ScatterPolylineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * The default style to apply to all Shapes in the series.
    */
    get shapeStyle() {
        if (this.i.ng == null) {
            return null;
        }
        if (!this.i.ng.externalObject) {
            let e = new IgxStyle();
            e._implementation = this.i.ng;
            this.i.ng.externalObject = e;
        }
        return this.i.ng.externalObject;
    }
    set shapeStyle(v) {
        v == null ? this.i.ng = null : this.i.ng = v.i;
    }
};
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", IgxStyle),
    tslib_1.__metadata("design:paramtypes", [IgxStyle])
], IgxScatterPolylineSeriesComponent.prototype, "shapeStyle", null);
IgxScatterPolylineSeriesComponent = IgxScatterPolylineSeriesComponent_1 = tslib_1.__decorate([
    Component({
        selector: 'igx-scatter-polyline-series',
        template: ``,
        providers: [{ provide: IgxShapeSeriesBaseComponent, useExisting: forwardRef(() => IgxScatterPolylineSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterPolylineSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxScatterPolylineSeriesComponent);
export { IgxScatterPolylineSeriesComponent };
//# sourceMappingURL=igx-scatter-polyline-series-component.js.map