import { ensureBool } from "igniteui-angular-core";
/**
 * Provides data for legend mouse button related events.
*/
var IgxLegendMouseButtonEventArgs = /** @class */ (function () {
    function IgxLegendMouseButtonEventArgs() {
    }
    Object.defineProperty(IgxLegendMouseButtonEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxLegendMouseButtonEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxLegendMouseButtonEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxLegendMouseButtonEventArgs.prototype, "handled", {
        /**
         * Gets or sets a value that indicates the present state of the event handling for a routed
         * event as it travels the route.
         * ChartMouseButton events are not routed events; setting this property effects the underlying
         * MouseButtonEvent.
        */
        get: function () {
            return this.i.handled;
        },
        set: function (v) {
            this.i.handled = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLegendMouseButtonEventArgs.prototype, "originalSource", {
        /**
         * Gets a reference to the object that raised the event.
        */
        get: function () {
            return this.i.originalSource;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLegendMouseButtonEventArgs.prototype, "item", {
        /**
         * Gets the ItemsSource item associated with the current event.
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLegendMouseButtonEventArgs.prototype, "series", {
        /**
         * Gets the series associated with the current event.
        */
        get: function () {
            return this.i.series;
        },
        set: function (v) {
            this.i.series = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLegendMouseButtonEventArgs.prototype, "chart", {
        /**
         * Gets the Chart associated with the current event.
        */
        get: function () {
            return this.i.chart;
        },
        set: function (v) {
            this.i.chart = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLegendMouseButtonEventArgs.prototype, "legendItem", {
        /**
         * The legend item that was the target of the mouse event.
        */
        get: function () {
            return this.i.legendItem;
        },
        set: function (v) {
            this.i.legendItem = v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Provides a human readable description of the mouse button event.
    
    */
    IgxLegendMouseButtonEventArgs.prototype.toString = function () {
        var iv = this.i.toString();
        return (iv);
    };
    return IgxLegendMouseButtonEventArgs;
}());
export { IgxLegendMouseButtonEventArgs };
//# sourceMappingURL=igx-legend-mouse-button-event-args.js.map