import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { UnknownValuePlotting, UnknownValuePlotting_$type } from "igniteui-angular-core";
import { IgxScatterBaseComponent } from "./igx-scatter-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { ScatterLineSeries } from "./ScatterLineSeries";
import { ensureEnum } from "igniteui-angular-core";
/**
 * Represents a IgxDataChartComponent scatter line series
*/
export var IgxScatterLineSeriesComponent_PROVIDERS = [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(function () { return IgxScatterLineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxScatterLineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxScatterLineSeriesComponent; }) }];
var IgxScatterLineSeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxScatterLineSeriesComponent, _super);
    function IgxScatterLineSeriesComponent() {
        return _super.call(this) || this;
    }
    IgxScatterLineSeriesComponent_1 = IgxScatterLineSeriesComponent;
    IgxScatterLineSeriesComponent.prototype.createImplementation = function () {
        return new ScatterLineSeries();
    };
    Object.defineProperty(IgxScatterLineSeriesComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxScatterLineSeriesComponent.prototype, "unknownValuePlotting", {
        /**
         * Determines how unknown values will be plotted on the chart.
         * Null and Double.NaN are two examples of unknown values.
        */
        get: function () {
            return this.i.ox;
        },
        set: function (v) {
            this.i.ox = ensureEnum(UnknownValuePlotting_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    var IgxScatterLineSeriesComponent_1;
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxScatterLineSeriesComponent.prototype, "unknownValuePlotting", null);
    IgxScatterLineSeriesComponent = IgxScatterLineSeriesComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-scatter-line-series',
            template: "",
            providers: [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(function () { return IgxScatterLineSeriesComponent_1; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxScatterLineSeriesComponent_1; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxScatterLineSeriesComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxScatterLineSeriesComponent);
    return IgxScatterLineSeriesComponent;
}(IgxScatterBaseComponent));
export { IgxScatterLineSeriesComponent };
//# sourceMappingURL=igx-scatter-line-series-component.js.map