import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { TreemapValueMappingMode, TreemapValueMappingMode_$type } from "./TreemapValueMappingMode";
import { IgxTreemapNodeStyleComponent } from "./igx-treemap-node-style-component";
import { TreemapNodeStyleMapping } from "./TreemapNodeStyleMapping";
import { ensureEnum } from "igniteui-angular-core";
/**
 * Represents a style to apply to a set of nodes in the treemap.
*/
export var IgxTreemapNodeStyleMappingComponent_PROVIDERS = [{ provide: IgxTreemapNodeStyleComponent, useExisting: forwardRef(function () { return IgxTreemapNodeStyleMappingComponent; }) }];
var IgxTreemapNodeStyleMappingComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxTreemapNodeStyleMappingComponent, _super);
    function IgxTreemapNodeStyleMappingComponent() {
        return _super.call(this) || this;
    }
    IgxTreemapNodeStyleMappingComponent_1 = IgxTreemapNodeStyleMappingComponent;
    IgxTreemapNodeStyleMappingComponent.prototype.createImplementation = function () {
        return new TreemapNodeStyleMapping();
    };
    Object.defineProperty(IgxTreemapNodeStyleMappingComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTreemapNodeStyleMappingComponent.prototype, "name", {
        /**
         * Gets or sets the unique name of the mapping.
        */
        get: function () {
            return this.i.a8;
        },
        set: function (v) {
            this.i.a8 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTreemapNodeStyleMappingComponent.prototype, "minimumValue", {
        /**
         * Gets or sets the minimum value to which the mapping applies.
        */
        get: function () {
            return this.i.a1;
        },
        set: function (v) {
            this.i.a1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTreemapNodeStyleMappingComponent.prototype, "maximumValue", {
        /**
         * Gets or sets the maximum value to which the mapping applies.
        */
        get: function () {
            return this.i.a0;
        },
        set: function (v) {
            this.i.a0 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTreemapNodeStyleMappingComponent.prototype, "value", {
        /**
         * Gets or sets the value to which the mapping applies.
        */
        get: function () {
            return this.i.a3;
        },
        set: function (v) {
            this.i.a3 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTreemapNodeStyleMappingComponent.prototype, "mappingMode", {
        /**
         * Gets or sets the mapping mode to use to evaluate whether the mapping applies.
        */
        get: function () {
            return this.i.ax;
        },
        set: function (v) {
            this.i.ax = ensureEnum(TreemapValueMappingMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    var IgxTreemapNodeStyleMappingComponent_1;
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String),
        tslib_1.__metadata("design:paramtypes", [String])
    ], IgxTreemapNodeStyleMappingComponent.prototype, "name", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxTreemapNodeStyleMappingComponent.prototype, "minimumValue", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxTreemapNodeStyleMappingComponent.prototype, "maximumValue", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Object),
        tslib_1.__metadata("design:paramtypes", [Object])
    ], IgxTreemapNodeStyleMappingComponent.prototype, "value", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxTreemapNodeStyleMappingComponent.prototype, "mappingMode", null);
    IgxTreemapNodeStyleMappingComponent = IgxTreemapNodeStyleMappingComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-treemap-node-style-mapping',
            template: "",
            providers: [{ provide: IgxTreemapNodeStyleComponent, useExisting: forwardRef(function () { return IgxTreemapNodeStyleMappingComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxTreemapNodeStyleMappingComponent);
    return IgxTreemapNodeStyleMappingComponent;
}(IgxTreemapNodeStyleComponent));
export { IgxTreemapNodeStyleMappingComponent };
//# sourceMappingURL=igx-treemap-node-style-mapping-component.js.map