import { Type } from "igniteui-angular-core";
/**
 * Describes available positions for axis title in respect to axis labels
 */
export declare enum AxisTitlePosition {
    /**
     * Displays the axis title in automatically selected position based on orientation and location of the axis:
     * <para/> - left title position for vertical axis located on left of the chart,
     * <para/> - right title position for vertical axis located on right of the chart,
     * <para/> - top title position for horizontal axis located on top of the chart,
     * <para/> - bottom title position for horizontal axis located on bottom of the chart,
     */
    Auto = 0,
    /**
     * Displays the axis title to the left of labels on vertical axis
     */
    Left = 1,
    /**
     * Displays the axis title to the right of labels on vertical axis
     */
    Right = 2,
    /**
     * Displays the axis title on top of labels on horizontal axis
     */
    Top = 3,
    /**
     * Displays the axis title on bottom of labels on horizontal axis
     */
    Bottom = 4
}
/**
 * @hidden
 */
export declare let AxisTitlePosition_$type: Type;
