import { Type } from "igniteui-angular-core";
/**
 * An enum representing the available display modes of crosshairs lines in the chart.
 */
export declare enum CrosshairsDisplayMode {
    /**
     * Display default number of crosshair lines in the chart.
     */
    Default = 0,
    /**
     * Display no crosshair lines in the chart.
     */
    None = 1,
    /**
     * Display horizontal line of crosshairs in the chart.
     */
    Horizontal = 2,
    /**
     * Display vertical line of crosshairs in the chart.
     */
    Vertical = 3,
    /**
     * Display both horizontal and vertical lines of crosshairs in the chart.
     */
    Both = 4
}
/**
 * @hidden
 */
export declare let CrosshairsDisplayMode_$type: Type;
