import { Type } from "igniteui-angular-core";
/**
 * Describes available modes for selecting slices.
 */
export declare enum SliceSelectionMode {
    /**
     * Slices can be programmatically selected but cannot be selected through the UI.
     */
    Manual = 0,
    /**
     * Single slice can be selected through the UI.
     */
    Single = 1,
    /**
     * Multiple slices can be selected through the UI.
     */
    Multiple = 2
}
/**
 * @hidden
 */
export declare let SliceSelectionMode_$type: Type;
