import { Type } from '@angular/core';
import { IgxSizeScaleComponent } from "./igx-size-scale-component";
import { IgxBrushScaleComponent } from "./igx-brush-scale-component";
import { IgxScatterBaseComponent } from "./igx-scatter-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { BubbleSeries } from "./BubbleSeries";
/**
 * Represents a IgxDataChartComponent bubble series.
*/
export declare const IgxBubbleSeriesComponent_PROVIDERS: ({
    provide: typeof IgxMarkerSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxBubbleSeriesComponent extends IgxScatterBaseComponent {
    protected createImplementation(): BubbleSeries;
    /**
                                 * @hidden
                                 */
    readonly i: BubbleSeries;
    constructor();
    /**
     * Gets or sets the radius mapping property for the current series object.
    */
    radiusMemberPath: string;
    /**
     * Gets or sets the radius size scale for the bubbles.
    */
    radiusScale: IgxSizeScaleComponent;
    /**
     * Gets or sets the Label mapping property for the current series object.
    */
    labelMemberPath: string;
    /**
     * Gets or sets the fill mapping property for the current series object.
    */
    fillMemberPath: string;
    /**
     * Gets or sets the brush scale for the marker brush.
    */
    fillScale: IgxBrushScaleComponent;
    /**
     * Overridden by derived series classes to indicate when markerless display is preferred or not.
    */
    readonly isMarkerlessDisplayPreferred: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    getItemValue(item: any, memberPathName: string): any;
}
