import { Type, OnDestroy, Renderer2, ElementRef, NgZone } from '@angular/core';
import { IgxLegendBaseComponent } from './igx-legend-base-component';
import { Legend } from "./Legend";
import { FinancialLegend } from './FinancialLegend';
export declare const IgxFinancialLegendComponent_PROVIDERS: {
    provide: typeof IgxLegendBaseComponent;
    useExisting: Type<any>;
}[];
/**
 * Represents a legend that displays information about each series, most often used in financial charting.
*/
export declare class IgxFinancialLegendComponent extends IgxLegendBaseComponent implements OnDestroy {
    private renderer;
    private elRef;
    private ngZone;
    container: Element;
    constructor(renderer: Renderer2, elRef: ElementRef, ngZone: NgZone);
    private _wrapper;
    ngOnDestroy(): void;
    protected createImplementation(): Legend;
    readonly i: FinancialLegend;
    /**
 * Gets if the legend is a financial legend.
*/
    readonly isFinancial: boolean;
}
