import { Type } from '@angular/core';
import { IgxNumericAxisBaseComponent } from "./igx-numeric-axis-base-component";
import { IgxAxisComponent } from "./igx-axis-component";
import { NumericAngleAxis } from "./NumericAngleAxis";
/**
 * Represents a IgxDataChartComponent angle based axis for polar series.
*/
export declare const IgxNumericAngleAxisComponent_PROVIDERS: {
    provide: typeof IgxAxisComponent;
    useExisting: Type<any>;
}[];
export declare class IgxNumericAngleAxisComponent extends IgxNumericAxisBaseComponent {
    protected createImplementation(): NumericAngleAxis;
    /**
                                 * @hidden
                                 */
    readonly i: NumericAngleAxis;
    constructor();
    /**
     * Gets if the current axis is of angular axis type
    */
    readonly isAngular: boolean;
    /**
     * Indicates the angle in degress that the chart's 0th angle should be offset.
    */
    startAngleOffset: number;
    /**
     * Gets the scaled angle value in radians based on the raw input.
    
    * @param unscaledValue  * The raw input value.
    */
    getScaledAngle(unscaledValue: number): number;
    /**
     * Gets the raw axis value back from the angle that would be used on the chart.
    
    * @param scaledValue  * The chart angle value.
    */
    getUnscaledAngle(scaledValue: number): number;
}
