import { IgSize } from "igniteui-angular-core";
import { IgPoint } from "igniteui-angular-core";
import { IgxRingSeriesBaseComponent } from "./igx-ring-series-base-component";
import { Ring as Ring_internal } from "./Ring";
/**
 * Represents data for Ring.RingControl element.
*/
export declare class IgxRing {
    protected createImplementation(): Ring_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: Ring_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the index of ring in the chart.
    */
    index: number;
    /**
     * Gets the inner extend of the ring in percentage.
    */
    innerExtend: number;
    /**
     * Gets the size of the ring.
    */
    controlSize: IgSize;
    /**
     * Gets the center point of the ring.
    */
    center: IgPoint;
    /**
     * Gets reference to ring series.
    */
    ringSeries: IgxRingSeriesBaseComponent;
    /**
     * Gets the ring breadth.
    */
    ringBreadth: number;
    /**
     * Renders the arcs.
    
    */
    renderArcs(): boolean;
    /**
     * Prepares data needed to create Arcs.
    
    */
    prepareArcs(): void;
}
