import { Type } from '@angular/core';
import { TreemapValueMappingMode } from "./TreemapValueMappingMode";
import { IgxTreemapNodeStyleComponent } from "./igx-treemap-node-style-component";
import { TreemapNodeStyleMapping } from "./TreemapNodeStyleMapping";
/**
 * Represents a style to apply to a set of nodes in the treemap.
*/
export declare const IgxTreemapNodeStyleMappingComponent_PROVIDERS: {
    provide: typeof IgxTreemapNodeStyleComponent;
    useExisting: Type<any>;
}[];
export declare class IgxTreemapNodeStyleMappingComponent extends IgxTreemapNodeStyleComponent {
    protected createImplementation(): TreemapNodeStyleMapping;
    /**
                                 * @hidden
                                 */
    readonly i: TreemapNodeStyleMapping;
    constructor();
    /**
     * Gets or sets the unique name of the mapping.
    */
    name: string;
    /**
     * Gets or sets the minimum value to which the mapping applies.
    */
    minimumValue: number;
    /**
     * Gets or sets the maximum value to which the mapping applies.
    */
    maximumValue: number;
    /**
     * Gets or sets the value to which the mapping applies.
    */
    value: any;
    /**
     * Gets or sets the mapping mode to use to evaluate whether the mapping applies.
    */
    mappingMode: TreemapValueMappingMode;
}
